# Django-react-tailwindcss

![Django-react-tailwindcss hello world page](https://i.imgur.com/yIAMkqy.png)

*Slightly* opinionated boilerplate for starting a Django project together with React front-end library and TailwindCSS CSS framework.

## Reasoning

Just a boilerplate for quickly creating new websites. You can change `yarn` with `npm` if you wish.
TailwindCSS and React are not mandatory, and you can use Django framework freely for working both on the front or the backend.

## Tooling

* Yarn - NodeJS package manager
* Pipenv - Python package manager
* Django for the backend (or the frontend too, as you wish)
* React front-end library
* Webpack JavaScript module bundler
* Babel JavaScript compiler
* TailwindCSS CSS framework
* Clean-CSS CSS optimizer

## Concepts

* Static files (generated or not) lives in the static directory.  

  e.g. for generated files: css files generated by
TailwindCSS and Clean-CSS and JS files by Webpack. 
  
  For the non generated files: images and fonts, etc.
  

* Files that generate other files live under `assets` directory. e.g. `assets/styles/tailwind.css` and `assets/js/index.js`

## Requirements

* Yarn or NPM package managers
* NodeJS >= 14
* Python >= 3.6
* Pipenv package manager

## Installing 

* Clone this git repository
    ``` bash
    $ git clone https://github.com/jvcarli/django-react-tailwindcss
    ```

* Inside the project folder install python and node requirements with:

    ``` bash
    $ pipenv install && yarn
    ```

* Build TailwindCSS static files with:

  ```bash
  $ yarn build
  ```

* **SECURITY**

  Inside the project root run `bootstrap.sh` script. It's just a simple bash script that runs a django internal command that regenerates Django SECRET_KEY (it must be **UNIQUE** for every project.).

  It only needs to be run once, it can be deleted after.

  ``` bash
  $ ./bootstrap.sh 
  ```

* Start Django server with:

  ```bash
  $ yarn dev
  ```

  You should be able to see a hello world page at http://localhost:8000/
  
* Develop

**ATTENTION:** `$ yarn dev` runs : `$ pipenv run python manage.py runserver` in the background.

If you **DO WISH** to use pip or any other python package manager open `package.json` file and remove `pipenv run`
from `pipenv run python manage.py runserver` and **remember** to **always** source your python virtual environment
**before** running `$ yarn dev`

`bootstrap.sh` runs `pipenv run` in the background too, so you'll need to remove `pipenv run` from the script and source
your virtual environment **before** running it.
